
# q-expansion of newform 366.2.a.f, downloaded from the LMFDB on 06 June 2024.

# We generate the q-expansion using the Hecke eigenvalues a_p at the primes.
# Each a_p is given as a linear combination
# of the following basis for the coefficient ring.

def make_data():

    from sage.all import prod, floor, prime_powers, gcd, QQ, primes_first_n, next_prime, RR

    def discrete_log(elts, gens, mod):
        # algorithm 2.2, page 16 of https://arxiv.org/abs/0903.2785
        def table_gens(gens, mod):
            T = [1]
            n = len(gens)
            r = [None]*n
            s = [None]*n
            for i in range(n):
                beta = gens[i]
                r[i] = 1
                N = len(T)
                while beta not in T:
                    for Tj in T[:N]:
                        T.append((beta*Tj) % mod)
                    beta = (beta*gens[i]) % mod
                    r[i] += 1
                s[i] = T.index(beta)
            return T, r, s
        T, r, s = table_gens(gens, mod)
        n = len(gens)
        N = [ prod(r[:j]) for j in range(n) ]
        Z = lambda s: [ (floor(s/N[j]) % r[j]) for j in range(n)]
        return [Z(T.index(elt % mod)) for elt in elts]
    def extend_multiplicatively(an):
        for pp in prime_powers(len(an)-1):
            for k in range(1, (len(an) - 1)//pp + 1):
                if gcd(k, pp) == 1:
                    an[pp*k] = an[pp]*an[k]
    from sage.all import PolynomialRing, NumberField
    R = PolynomialRing(QQ, "x")
    f = R(poly_data)
    K = NumberField(f, "a")
    betas = [K.gens()[0]**i for i in range(len(poly_data))]
    convert_elt_to_field = lambda elt: sum(c*beta for c, beta in zip(elt, betas))
    # convert aps to K elements
    primes = primes_first_n(len(aps_data))
    good_primes = [p for p in primes if not p.divides(level)]
    aps = map(convert_elt_to_field, aps_data)
    if not hecke_ring_character_values:
        # trivial character
        char_values = dict(zip(good_primes, [1]*len(good_primes)))
    else:
        gens = [elt[0] for elt in hecke_ring_character_values]
        gens_values = [convert_elt_to_field(elt[1]) for elt in hecke_ring_character_values]
        char_values = dict([(
            p,prod(g**k for g, k in zip(gens_values, elt)))
            for p, elt in zip(good_primes, discrete_log(good_primes, gens, level))
            ])
    an_list_bound = next_prime(primes[-1])
    an = [0]*an_list_bound
    an[1] = 1
    
    from sage.all import PowerSeriesRing
    PS = PowerSeriesRing(K, "q")
    for p, ap in zip(primes, aps):
        if p.divides(level):
            euler_factor = [1, -ap]
        else:
            euler_factor = [1, -ap, p**(weight - 1) * char_values[p]]
        k = RR(an_list_bound).log(p).floor() + 1
        foo = (1/PS(euler_factor)).padded_list(k)
        for i in range(1, k):
            an[p**i] = foo[i]
    extend_multiplicatively(an)
    return PS(an)
level = 366
weight = 2
poly_data = [0, 1]

# The basis for the coefficient ring is just the power basis
# in the root of the defining polynomial above.
hecke_ring_character_values = None
aps_data = [[1], [1], [1], [-2], [2], [4], [-7], [0], [9], [-10], [-8], [-7], [12], [-1], [8], [-6], [0], [1], [-12], [-3], [-1], [10], [-1], [5], [-17], [12], [-1], [13], [0], [4], [13], [-3], [-12], [5], [10], [22], [18], [-16], [-2], [14], [15], [7], [12], [4], [18], [5], [12], [-6], [18], [-10], [-26], [-10], [17], [-18], [-12], [4], [10], [27], [-22], [-18], [-16], [9], [13], [-8], [-6], [-27], [7], [-2], [-27], [15], [34], [-25], [-32], [-31], [-20], [24], [-10], [23], [-23], [0], [0], [17], [-18], [-16], [15], [19], [10], [-2], [-13], [-1], [8], [10], [-32], [-8], [-5], [4], [20], [22], [-41], [-23], [-12], [18], [-16], [20], [-8], [-12], [18], [-21], [15], [-3], [23], [4], [-27], [10], [22], [27], [19], [-37], [24], [15], [42], [-46], [-12], [-11], [42], [-38], [-5], [-20], [-32], [34], [35], [-41], [-23], [38], [22], [0], [-31], [28], [-2], [30], [-33], [22], [-26], [43], [-10], [0], [14], [-22], [-40], [24], [-27], [-18], [-31], [-37], [-7], [12], [5], [0], [-57], [12], [48], [-11], [53], [-23], [-52], [-16], [-28], [53]]
